#include <sourcemod>
#include <sdktools>
#include <shop>
#include <multicolors>
#pragma tabsize 0
#define PREFIX " \x04[Больше или Меньше]\x01"
#define MENUPREFIX "[High Or Low]"
#define cooldown g_cvCooldownTime.FloatValue

int g_iRand1, g_iRand2;
int timeleft;
int g_iManualAmount[MAXPLAYERS + 1] = 100;
bool g_bTypingAmount[MAXPLAYERS + 1] = false;
ConVar g_cvMinAmount;
ConVar g_cvMaxAmount;
ConVar g_cvCooldownTime;
Handle CommandHandle;
float currentTime;
float gametime;
float timepassed;

public Plugin myinfo = 
{
	name = "High or Low",
	author = "SheriF and donut1k",
	description = "Higher & Lower Gamble",
	version = "1.1",
	url = ""
};

public void OnPluginStart()
{
	RegConsoleCmd("sm_hol", highorlow);
	g_cvMinAmount = CreateConVar("sm_hol_min_amount", "50", "The minimum amount of Credits to play High or Low");
	g_cvMaxAmount = CreateConVar("sm_hol_max_amount", "500", "The maximum amount of Credits to play High or Low");
	g_cvCooldownTime = CreateConVar("sm_cooldown_time", "30.0", "Cooldown for the high or low command. Usage: The amount of second between each try of the command . 0.0-Disable.");
	AutoExecConfig(true, "highorlow");
	
	if (Shop_IsStarted())
	{
		Shop_Started();
	}
}

public Shop_Started()
{
    Shop_AddToFunctionsMenu(FunctionDisplay, FunctionSelect);
}

public FunctionDisplay(client, String:buffer[], maxlength)
{
    char title[64];
    FormatEx(title, sizeof(title), "Игра Больше или Меньше");

    strcopy(buffer, maxlength, title);
}

public bool FunctionSelect(int client)
{
	ShowMainMenu(client);
	return true;
}

public void OnClientPostAdminCheck(int client)
{
	g_iManualAmount[client] = 100;
	g_bTypingAmount[client] = false;
}

public Action highorlow(int client, int args)
{
	if (IsClientInGame(client) && !IsFakeClient(client))
	{
		ShowMainMenu(client);
	}
	return Plugin_Handled;
}
public Action TimerFunction(Handle timer)
{
	currentTime = 0.0;
	CommandHandle = null;
    return Plugin_Handled;
}

public int menuHandler_HolMenu(Menu menu, MenuAction action, int client, int itemNUM)
{
	if (action == MenuAction_Select)
	{
		switch (itemNUM)
		{
			case 0:
			{
				g_bTypingAmount[client] = true;
				PrintToChat(client, "Пожалуйста, введите количество кредитов в чате");
			}
			case 1:
			{
				if (Shop_GetClientCredits(client) < g_iManualAmount[client])
					CPrintToChat(client, "%s У вас недостаточно кредитов, чтобы играть в Больше или Меньше",PREFIX);

				else
				{
					if (CommandHandle != null)
					{
						delete menu;
  	 					gametime = GetGameTime();
     					timepassed = gametime-currentTime;
     					timeleft = RoundFloat(cooldown - timepassed);
	 					CPrintToChat(client,"%s Вам придется подождать \x07%d\x01 секунд перед повторной попыткой сыграть в игру.",PREFIX,timeleft);
  				    }
  				    else
  				    {
  				    	currentTime = GetGameTime();
						CommandHandle = CreateTimer(cooldown , TimerFunction);
						g_iRand1 = GetRandomInt(2, 99);
						g_iRand2 = GetRandomInt(1, 100);
						while(g_iRand1==g_iRand2)
		 					g_iRand2 = GetRandomInt(1, 100);
						Menu HolMenu1 = new Menu(menuHandler_HolMenu1);
						HolMenu1.SetTitle("%s Число от 1 до 100 было выбрано для вас\n угадайте, будет ли следующее число Больше или Меньше выбранного числа", MENUPREFIX);
						HolMenu1.AddItem("","Больше");
						HolMenu1.AddItem("","Меньше");
						HolMenu1.ExitButton = false;
						HolMenu1.Display(client, MENU_TIME_FOREVER);
						Shop_SetClientCredits(client, Shop_GetClientCredits(client) - g_iManualAmount[client]);
						PrintCenterText(client,"Выбранный номер: \x10%d", g_iRand1);
						CPrintToChat(client,"%s Выбранный номер: \x10%d", PREFIX,g_iRand1);
					}
				}
			}
		}
	}
}

public int menuHandler_HolMenu1 (Menu menu, MenuAction action, int client, int ItemNum)
{
	if (action == MenuAction_Select)
	{
		switch (ItemNum)
		{
			case 0:
			{
				if(g_iRand2>g_iRand1)
				{
					int win = (100/(100-g_iRand1));
					int credits = g_iManualAmount[client] * win;
					if(credits==g_iManualAmount[client])
					{
						credits = 2*g_iManualAmount[client];
						CPrintToChat(client, "%s Вы выиграли \x04%d\x01 Кредитов", PREFIX,(credits/2));
					}
					else if(credits != g_iManualAmount[client])
						CPrintToChat(client, "%s Вы выиграли \x04%d\x01 Кредитов", PREFIX,credits);
	
					Shop_SetClientCredits(client, Shop_GetClientCredits(client) + credits);
				}
				else
					CPrintToChat(client, "%s Вы \x07проиграли\x01 свою ставку",PREFIX);

				PrintCenterText(client,"Следующий номер был: \x10%d", g_iRand2);
				CPrintToChat(client,"%s Следующий номер был: \x10%d", PREFIX,g_iRand2);
			}
			case 1:
			{
				if(g_iRand2<g_iRand1)
				{
					int win = (100/(g_iRand1));
					int credits = g_iManualAmount[client] * win;
					if(credits==g_iManualAmount[client])
					{
						credits = 2*g_iManualAmount[client];
						CPrintToChat(client, "%s Вы выиграли \x04%d\x01 Кредитов", PREFIX,(credits/2));
					}
					else if(credits != g_iManualAmount[client])
						CPrintToChat(client, "%s Вы выиграли \x04%d\x01 Кредитов", PREFIX,credits);
	
					Shop_SetClientCredits(client, Shop_GetClientCredits(client) + credits);
				}
				else
					CPrintToChat(client, "%s Вы \x07проиграли\x01 свою ставку",PREFIX);

				PrintCenterText(client,"Следующий номер был: \x10%d", g_iRand2);
				CPrintToChat(client,"%s Следующий номер был: \x10%d", PREFIX,g_iRand2);
			}
		}
	}
}

public Action OnClientSayCommand(int client, const char[] command, const char[] sArgs)
{
	if (g_bTypingAmount[client])
	{
		if (IsNumeric(sArgs))
		{
			int iMinAmount = g_cvMinAmount.IntValue;
			int iMaxAmount = g_cvMaxAmount.IntValue;
			int iAmount = StringToInt(sArgs);
			if (iAmount < iMinAmount)
			{
				PrintToChat(client, "%s Минимальное количество кредитов для игры \x10%i", PREFIX, iMinAmount);
				return Plugin_Handled;
			}
			else if (iAmount > iMaxAmount)
			{
				PrintToChat(client, "%s Максимальное количество кредитов для игры \x10%i", PREFIX, iMaxAmount);
				return Plugin_Handled;
			}
			g_iManualAmount[client] = iAmount;
			PrintToChat(client, "%s Вы выбрали \x10%i\x01 Кредитов для игры", PREFIX, iAmount);
		}
		else
			PrintToChat(client, "%s Вы можете вводить только цифры..", PREFIX);
		
		ShowMainMenu(client);
		g_bTypingAmount[client] = false;
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

stock bool IsNumeric(const char[] buffer)
{
	int iLen = strlen(buffer);
	for (int i = 0; i < iLen; i++)
	{
		if (!IsCharNumeric(buffer[i]))
			return false;
	}
	return true;
}

void ShowMainMenu(int client)
{
	Menu HolMenu = new Menu(menuHandler_HolMenu);
	HolMenu.SetTitle("%s Больше или Меньше", MENUPREFIX);
	char szItem1[256];
	Format(szItem1, sizeof(szItem1), "Текущая сумма ставки : %i\n[Нажмите, чтобы изменить]", g_iManualAmount[client]);
	HolMenu.AddItem("", szItem1);
	HolMenu.AddItem("", "Начать игру!");
	HolMenu.ExitButton = true;
	HolMenu.Display(client, MENU_TIME_FOREVER);
}